include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "div_mod.ma".
include "leibniz.ma".
include "logic.ma".
include "nat.ma".
include "primes.ma".
axiom gcd_aux : nat -> nat -> nat -> nat.
axiom gcd_aux_body : nat -> nat -> nat -> nat.
axiom axiom_gcd_aux : \forall (p:nat). (equal) (nat -> nat -> nat) ((gcd_aux)  p) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p).
definition eq_gcd_aux : \forall (p:nat). (leibniz) (nat -> nat -> nat) ((gcd_aux)  p) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p) := \lambda p : nat. ((((equal_leibniz) (nat -> nat -> nat)) ((gcd_aux)  p)) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p)) ((axiom_gcd_aux) (p)).
definition sym_eq_gcd_aux : \forall (p:nat). (leibniz) (nat -> nat -> nat) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p) ((gcd_aux)  p) := \lambda p : nat. ((((sym_leibniz) (nat -> nat -> nat)) ((gcd_aux)  p)) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p)) ((eq_gcd_aux) (p)).
axiom axiom_gcd_aux_body_O : (equal) (nat -> nat -> nat) ((gcd_aux_body)  (O) ) (\lambda m : nat. \lambda n : nat. m).
definition eq_gcd_aux_body_O : (leibniz) (nat -> nat -> nat) ((gcd_aux_body)  (O) ) (\lambda m : nat. \lambda n : nat. m) := ((((equal_leibniz) (nat -> nat -> nat)) ((gcd_aux_body)  (O) )) (\lambda m : nat. \lambda n : nat. m)) (axiom_gcd_aux_body_O).
axiom axiom_gcd_aux_body_S : \forall (p:nat). (equal) (nat -> nat -> nat) ((gcd_aux_body)  ((S)  p)) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m)).
definition eq_gcd_aux_body_S : \forall (p:nat). (leibniz) (nat -> nat -> nat) ((gcd_aux_body)  ((S)  p)) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m)) := \lambda p : nat. ((((equal_leibniz) (nat -> nat -> nat)) ((gcd_aux_body)  ((S)  p))) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m))) ((axiom_gcd_aux_body_S) (p)).
definition sym_eq_gcd_aux_body_S : \forall (p:nat). (leibniz) (nat -> nat -> nat) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m)) ((gcd_aux_body)  ((S)  p)) := \lambda p : nat. ((((sym_leibniz) (nat -> nat -> nat)) ((gcd_aux_body)  ((S)  p))) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m))) ((eq_gcd_aux_body_S) (p)).
definition gcd : nat -> nat -> nat := \lambda n : nat. \lambda m : nat. (match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) ((leb)  n m).
definition commutative_gcd : \forall (n:nat). \forall (m:nat). (eq) (nat) ((gcd)  n m) ((gcd)  m n) := \lambda n : nat. \lambda m : nat. (((((leb_elim) (n)) (m)) (\lambda j__ : bool. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) j__) ((match_bool_type) (nat) ((gcd_aux)  m n m) ((gcd_aux)  n m n) ((leb)  m n)))) (\lambda lenm : (le)  n m. (((((((match_Or_prop) ((lt)  n m)) ((eq) (nat) n m)) ((eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (true) ) ((match_bool_type) (nat) ((gcd_aux)  m n m) ((gcd_aux)  n m n) ((leb)  m n)))) (\lambda ltnm : (lt)  n m. (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (true) ) ((match_bool_type) (nat) ((gcd_aux)  m n m) ((gcd_aux)  n m n) x))) ((((((sym_eq_match_bool_type_false) (nat)) ((gcd_aux)  m n m)) ((gcd_aux)  n m n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (true) ) y)) ((((((eq_match_bool_type_true) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (true) ) y)) (((refl) (nat)) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (true) ))))) ((leb)  m n)) ((((not_le_to_leb_false) (m)) (n)) ((((lt_to_not_le) (n)) (m)) (ltnm)))))) (\lambda eqnm : (eq) (nat) n m. (((((((eq_ind_r) (nat)) (m)) (\lambda x : nat. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  x m x) ((gcd_aux)  m x m) (true) ) ((match_bool_type) (nat) ((gcd_aux)  m x m) ((gcd_aux)  x m x) ((leb)  m x)))) (((((match_bool_prop) (\lambda j__ : bool. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  m m m) ((gcd_aux)  m m m) (true) ) ((match_bool_type) (nat) ((gcd_aux)  m m m) ((gcd_aux)  m m m) j__))) (((refl) (nat)) ((match_bool_type) (nat) ((gcd_aux)  m m m) ((gcd_aux)  m m m) (true) ))) ((((((sym_eq_match_bool_type_false) (nat)) ((gcd_aux)  m m m)) ((gcd_aux)  m m m)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  m m m) ((gcd_aux)  m m m) (true) ) y)) ((((((eq_match_bool_type_true) (nat)) ((gcd_aux)  m m m)) ((gcd_aux)  m m m)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  m m m) ((gcd_aux)  m m m) (true) ) y)) (((refl) (nat)) ((match_bool_type) (nat) ((gcd_aux)  m m m) ((gcd_aux)  m m m) (true) ))))) ((leb)  m m))) (n)) (eqnm)))) ((((le_to_or_lt_eq) (n)) (m)) (lenm))))) (\lambda notlenm : (Not)  ((le)  n m). (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (false) ) ((match_bool_type) (nat) ((gcd_aux)  m n m) ((gcd_aux)  n m n) x))) ((((((sym_eq_match_bool_type_false) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. (eq) (nat) y ((match_bool_type) (nat) ((gcd_aux)  m n m) ((gcd_aux)  n m n) (true) ))) ((((((sym_eq_match_bool_type_true) (nat)) ((gcd_aux)  m n m)) ((gcd_aux)  n m n)) (\lambda y : nat. (eq) (nat) ((gcd_aux)  m n m) y)) ((((((eq_match_bool_type_false) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. (eq) (nat) ((gcd_aux)  m n m) y)) ((((((eq_match_bool_type_false) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. (eq) (nat) y ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (false) ))) (((refl) (nat)) ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (false) ))))))) ((leb)  m n)) ((((le_to_leb_true) (m)) (n)) ((((((transitive_le) (m)) ((S)  m)) (n)) ((le_n_Sn) (m))) ((((not_le_to_lt) (n)) (m)) (notlenm)))))).
definition gcd_O_l : \forall (m:nat). (eq) (nat) ((gcd)  (O)  m) m := \lambda m : nat. (((((eq_match_bool_type_true) (nat)) (m)) ((gcd_aux)  m (O)  m)) (\lambda y : nat. (eq) (nat) ((gcd)  (O)  m) y)) (((eq_leb_body_O) (\lambda y : nat -> bool. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) (((((eq_filter_nat_type_O) (nat -> bool)) ((leb_body) )) (\lambda y : nat -> bool. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) ((((eq_leb) ((O) )) (\lambda y : nat -> bool. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) (((eq_gcd_aux_body_O) (\lambda y : nat -> nat -> nat. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) (((((eq_filter_nat_type_O) (nat -> nat -> nat)) ((gcd_aux_body) )) (\lambda y : nat -> nat -> nat. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) ((((eq_gcd_aux) ((O) )) (\lambda y : nat -> nat -> nat. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) (((refl) (nat)) ((gcd)  (O)  m)))))))).
definition divides_mod_to_divides : \forall (p:nat). \forall (m:nat). \forall (n:nat). ((lt)  (O)  n) -> ((divides)  p ((mod)  m n)) -> ((divides)  p n) -> (divides)  p m := \lambda p : nat. \lambda m : nat. \lambda n : nat. \lambda posn : (lt)  (O)  n. (\lambda j_clearme : (divides)  p ((mod)  m n). ((((((match_divides_prop) (p)) ((mod)  m n)) (((divides)  p n) -> (divides)  p m)) (\lambda q1 : nat. \lambda eq1 : (eq) (nat) ((mod)  m n) ((times)  p q1). (\lambda j_clearme0 : (divides)  p n. ((((((match_divides_prop) (p)) (n)) ((divides)  p m)) (\lambda q2 : nat. \lambda eq2 : (eq) (nat) n ((times)  p q2). (((((quotient) (p)) (m)) ((plus)  ((times)  q2 ((div)  m n)) q1)) (((((((eq_ind_r) (nat)) ((plus)  ((times)  p ((times)  q2 ((div)  m n))) ((times)  p q1))) (\lambda x : nat. (eq) (nat) m x)) (((((((eq_ind) (nat)) ((mod)  m n)) (\lambda x_1 : nat. (eq) (nat) m ((plus)  ((times)  p ((times)  q2 ((div)  m n))) x_1))) (((((((eq_ind) (nat)) ((times)  ((times)  p q2) ((div)  m n))) (\lambda x_1 : nat. (eq) (nat) m ((plus)  x_1 ((mod)  m n)))) (((((((eq_ind) (nat)) (n)) (\lambda x_1 : nat. (eq) (nat) m ((plus)  ((times)  x_1 ((div)  m n)) ((mod)  m n)))) (((((((rewrite_r) (nat)) ((plus)  ((mod)  m n) ((times)  n ((div)  m n)))) (\lambda j__ : nat. (eq) (nat) m j__)) (((((((rewrite_l) (nat)) (m)) (\lambda j__ : nat. (eq) (nat) m j__)) (((refl) (nat)) (m))) ((plus)  ((mod)  m n) ((times)  n ((div)  m n)))) (((((((rewrite_l) (nat)) ((plus)  ((times)  n ((div)  m n)) ((mod)  m n))) (\lambda j__ : nat. (eq) (nat) m j__)) (((((((rewrite_l) (nat)) ((times)  ((div)  m n) n)) (\lambda j__ : nat. (eq) (nat) m ((plus)  j__ ((mod)  m n)))) (((div_mod) (m)) (n))) ((times)  n ((div)  m n))) (((commutative_times) ((div)  m n)) (n)))) ((plus)  ((mod)  m n) ((times)  n ((div)  m n)))) (((commutative_plus) ((times)  n ((div)  m n))) ((mod)  m n))))) ((plus)  ((times)  n ((div)  m n)) ((mod)  m n))) (((commutative_plus) ((times)  n ((div)  m n))) ((mod)  m n)))) ((times)  p q2)) (eq2))) ((times)  p ((times)  q2 ((div)  m n)))) ((((associative_times) (p)) (q2)) ((div)  m n)))) ((times)  p q1)) (eq1))) ((times)  p ((plus)  ((times)  q2 ((div)  m n)) q1))) ((((distributive_times_plus) (p)) ((times)  q2 ((div)  m n))) (q1)))))) (j_clearme0))))) (j_clearme))).
definition divides_to_gcd_aux : \forall (p:nat). \forall (m:nat). \forall (n:nat). ((lt)  (O)  p) -> ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) ((gcd_aux)  p m n) n := \lambda p : nat. \lambda m : nat. \lambda n : nat. \lambda posp : (lt)  (O)  p. (((((lt_O_n_elim) (p)) (posp)) (\lambda j__ : nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) ((gcd_aux)  j__ m n) n)) (\lambda l : nat. (((sym_eq_gcd_aux) ((S)  l)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) (y m n) n)) ((((((sym_eq_filter_nat_type_S) (nat -> nat -> nat)) ((gcd_aux_body) )) (l)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) (y m n) n)) ((((sym_eq_gcd_aux_body_S) (l)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) (y m n) n)) (\lambda posn : (lt)  (O)  n. (\lambda divnm : (divides)  n m. (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) n ((gcd_aux)  l n ((mod)  m n)) x) n)) ((((((sym_eq_match_bool_type_true) (nat)) (n)) ((gcd_aux)  l n ((match_nat_type) (nat) m (\lambda p0 : nat. (mod_aux)  m m p0) n))) (\lambda y : nat. (eq) (nat) y n)) (((refl) (nat)) (n)))) ((dividesb)  n m)) (((((divides_to_dividesb_true) (n)) (m)) (posn)) (divnm))))))))).
definition not_divides_to_gcd_aux : \forall (p:nat). \forall (m:nat). \forall (n:nat). ((lt)  (O)  n) -> ((Not)  ((divides)  n m)) -> (eq) (nat) ((gcd_aux)  ((S)  p) m n) ((gcd_aux)  p n ((mod)  m n)) := \lambda p : nat. \lambda m : nat. \lambda n : nat. (((sym_eq_gcd_aux) ((S)  p)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((Not)  ((divides)  n m)) -> (eq) (nat) (y m n) ((gcd_aux)  p n ((mod)  m n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat -> nat)) ((gcd_aux_body) )) (p)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((Not)  ((divides)  n m)) -> (eq) (nat) (y m n) ((gcd_aux)  p n ((mod)  m n)))) ((((sym_eq_gcd_aux_body_S) (p)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((Not)  ((divides)  n m)) -> (eq) (nat) (y m n) ((gcd_aux)  p n ((mod)  m n)))) (\lambda lenm : (lt)  (O)  n. (\lambda divnm : (Not)  ((divides)  n m). (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) x) ((gcd_aux)  p n ((mod)  m n)))) ((((((sym_eq_match_bool_type_false) (nat)) (n)) ((gcd_aux)  p n ((match_nat_type) (nat) m (\lambda p0 : nat. (mod_aux)  m m p0) n))) (\lambda y : nat. (eq) (nat) y ((gcd_aux)  p n ((match_nat_type) (nat) m (\lambda p0 : nat. (mod_aux)  m m p0) n)))) (((refl) (nat)) ((gcd_aux)  p n ((match_nat_type) (nat) m (\lambda p0 : nat. (mod_aux)  m m p0) n))))) ((dividesb)  n m)) (((((not_divides_to_dividesb_false) (n)) (m)) (lenm)) (divnm))))))).
definition divides_gcd_aux_mn : \forall (p:nat). \forall (m:nat). \forall (n:nat). ((lt)  (O)  n) -> ((le)  n m) -> ((le)  n p) -> (And)  ((divides)  ((gcd_aux)  p m n) m) ((divides)  ((gcd_aux)  p m n) n) := \lambda p : nat. ((((nat_ind) (\lambda j_x_365 : nat. \forall (m:nat). \forall (n:nat). ((lt)  (O)  n) -> ((le)  n m) -> ((le)  n j_x_365) -> (And)  ((divides)  ((gcd_aux)  j_x_365 m n) m) ((divides)  ((gcd_aux)  j_x_365 m n) n))) (\lambda m : nat. \lambda n : nat. \lambda posn : (lt)  (O)  n. (\lambda lenm : (le)  n m. (\lambda lenO : (le)  n (O) . (((falsity) ((And)  ((divides)  ((gcd_aux)  (O)  m n) m) ((divides)  ((gcd_aux)  (O)  m n) n))) ((((absurd) ((lt)  (O)  n)) (posn)) ((((le_to_not_lt) (n)) ((O) )) (lenO)))))))) (\lambda q : nat. \lambda Hind : \forall (m:nat). \forall (n:nat). ((lt)  (O)  n) -> ((le)  n m) -> ((le)  n q) -> (And)  ((divides)  ((gcd_aux)  q m n) m) ((divides)  ((gcd_aux)  q m n) n). (\lambda m : nat. \lambda n : nat. \lambda posn : (lt)  (O)  n. (\lambda lenm : (le)  n m. (\lambda lenS : (le)  n ((S)  q). (((((((match_Or_prop) ((divides)  n m)) ((Not)  ((divides)  n m))) ((And)  ((divides)  ((gcd_aux)  ((S)  q) m n) m) ((divides)  ((gcd_aux)  ((S)  q) m n) n))) (\lambda divnm : (divides)  n m. (((((((eq_ind_r) (nat)) (n)) (\lambda x : nat. (And)  ((divides)  x m) ((divides)  x n))) (((((conj) ((divides)  n m)) ((divides)  n n)) (divnm)) ((divides_n_n) (n)))) ((gcd_aux)  ((S)  q) m n)) (((((((divides_to_gcd_aux) ((S)  q)) (m)) (n)) ((lt_O_S) (q))) (posn)) (divnm))))) (\lambda ndivnm : (Not)  ((divides)  n m). (((((((eq_ind_r) (nat)) ((gcd_aux)  q n ((mod)  m n))) (\lambda x : nat. (And)  ((divides)  x m) ((divides)  x n))) ((((((match_And_prop) ((divides)  ((gcd_aux)  q n ((mod)  m n)) n)) ((divides)  ((gcd_aux)  q n ((mod)  m n)) ((mod)  m n))) ((And)  ((divides)  ((gcd_aux)  q n ((mod)  m n)) m) ((divides)  ((gcd_aux)  q n ((mod)  m n)) n))) (\lambda H : (divides)  ((gcd_aux)  q n ((mod)  m n)) n. (\lambda H1 : (divides)  ((gcd_aux)  q n ((mod)  m n)) ((mod)  m n). (((((conj) ((divides)  ((gcd_aux)  q n ((mod)  m n)) m)) ((divides)  ((gcd_aux)  q n ((mod)  m n)) n)) (((((((divides_mod_to_divides) ((gcd_aux)  q n ((mod)  m n))) (m)) (n)) (posn)) (H1)) (H))) (H))))) ((((((Hind) (n)) ((mod)  m n)) (((((((match_Or_prop) ((lt)  (O)  ((mod)  m n))) ((eq) (nat) (O)  ((mod)  m n))) ((lt)  (O)  ((mod)  m n))) (\lambda auto : (lt)  (O)  ((mod)  m n). (auto))) (\lambda modO : (eq) (nat) (O)  ((mod)  m n). (((falsity) ((lt)  (O)  ((mod)  m n))) ((((absurd) ((divides)  n m)) (((((mod_O_to_divides) (n)) (m)) (posn)) (((((((rewrite_l) (nat)) ((O) )) (\lambda j__ : nat. (eq) (nat) j__ (O) )) (((refl) (nat)) ((O) ))) ((mod)  m n)) (modO)))) (ndivnm))))) ((((le_to_or_lt_eq) ((O) )) ((mod)  m n)) ((le_O_n) ((mod)  m n))))) ((((lt_to_le) ((mod)  m n)) (n)) ((((lt_mod_m_m) (m)) (n)) (posn)))) ((((le_S_S_to_le) ((mod)  m n)) (q)) ((((((transitive_le) ((S)  ((mod)  m n))) (n)) ((S)  q)) ((((lt_mod_m_m) (m)) (n)) (posn))) (lenS)))))) ((gcd_aux)  ((S)  q) m n)) ((((((not_divides_to_gcd_aux) (q)) (m)) (n)) (posn)) (ndivnm))))) (((decidable_divides) (n)) (m)))))))) (p).
definition divides_gcd_nm : \forall (n:nat). \forall (m:nat). (And)  ((divides)  ((gcd)  n m) m) ((divides)  ((gcd)  n m) n) := \lambda n : nat. \lambda m : nat. ((((((match_Or_prop) ((lt)  (O)  n)) ((eq) (nat) (O)  n)) ((And)  ((divides)  ((gcd)  n m) m) ((divides)  ((gcd)  n m) n))) (\lambda posn : (lt)  (O)  n. (((((((match_Or_prop) ((lt)  (O)  m)) ((eq) (nat) (O)  m)) ((And)  ((divides)  ((gcd)  n m) m) ((divides)  ((gcd)  n m) n))) (\lambda posm : (lt)  (O)  m. ((((((leb_elim) (n)) (m)) (\lambda j__ : bool. (And)  ((divides)  ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) j__) m) ((divides)  ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) j__) n))) ((((((sym_eq_match_bool_type_true) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. ((le)  n m) -> (And)  ((divides)  ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (true) ) m) ((divides)  y n))) ((((((sym_eq_match_bool_type_true) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. ((le)  n m) -> (And)  ((divides)  y m) ((divides)  ((gcd_aux)  n m n) n))) (\lambda lenm : (le)  n m. (((((((divides_gcd_aux_mn) (n)) (m)) (n)) (posn)) (lenm)) ((le_n) (n))))))) ((((((sym_eq_match_bool_type_false) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. ((Not)  ((le)  n m)) -> (And)  ((divides)  ((match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) (false) ) m) ((divides)  y n))) ((((((sym_eq_match_bool_type_false) (nat)) ((gcd_aux)  n m n)) ((gcd_aux)  m n m)) (\lambda y : nat. ((Not)  ((le)  n m)) -> (And)  ((divides)  y m) ((divides)  ((gcd_aux)  m n m) n))) (\lambda notlt : (Not)  ((le)  n m). ((((((match_And_prop) ((divides)  ((gcd_aux)  m n m) n)) ((divides)  ((gcd_aux)  m n m) m)) ((And)  ((divides)  ((gcd_aux)  m n m) m) ((divides)  ((gcd_aux)  m n m) n))) (\lambda auto : (divides)  ((gcd_aux)  m n m) n. (\lambda auto' : (divides)  ((gcd_aux)  m n m) m. (((((conj) ((divides)  ((gcd_aux)  m n m) m)) ((divides)  ((gcd_aux)  m n m) n)) (auto')) (auto))))) (((((((divides_gcd_aux_mn) (m)) (n)) (m)) (posm)) ((((((transitive_le) (m)) ((S)  m)) (n)) ((le_n_Sn) (m))) ((((not_le_to_lt) (n)) (m)) (notlt)))) ((le_n) (m)))))))))) (\lambda eqmO : (eq) (nat) (O)  m. (((((((eq_ind) (nat)) ((O) )) (\lambda x_1 : nat. (And)  ((divides)  ((gcd)  n x_1) x_1) ((divides)  ((gcd)  n x_1) n))) (((((conj) ((divides)  ((gcd)  n (O) ) (O) )) ((divides)  ((gcd)  n (O) ) n)) ((divides_n_O) ((gcd)  n (O) ))) (((((eq_coerc) ((divides)  ((gcd)  n (O) ) ((gcd)  n (O) ))) ((divides)  ((gcd)  n (O) ) n)) ((divides_n_n) ((gcd)  n (O) ))) (((((((rewrite_r) (nat)) (n)) (\lambda j__ : nat. (eq) (Prop) ((divides)  ((gcd)  n (O) ) j__) ((divides)  ((gcd)  n (O) ) n))) (((refl) (Prop)) ((divides)  ((gcd)  n (O) ) n))) ((gcd)  n (O) )) (((((((rewrite_l) (nat)) ((gcd)  (O)  n)) (\lambda j__ : nat. (eq) (nat) ((gcd)  n (O) ) j__)) (((commutative_gcd) (n)) ((O) ))) (n)) ((gcd_O_l) (n))))))) (m)) (eqmO)))) ((((le_to_or_lt_eq) ((O) )) (m)) ((le_O_n) (m)))))) (\lambda eqnO : (eq) (nat) (O)  n. (((((((eq_ind) (nat)) ((O) )) (\lambda x_1 : nat. (And)  ((divides)  ((gcd)  x_1 m) m) ((divides)  ((gcd)  x_1 m) x_1))) (((((conj) ((divides)  ((gcd)  (O)  m) m)) ((divides)  ((gcd)  (O)  m) (O) )) ((((((eq_match_bool_type_true) (nat)) (m)) ((gcd_aux)  m (O)  m)) (\lambda y : nat. (divides)  ((match_bool_type) (nat) ((gcd_aux)  (O)  m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)) y)) (((eq_leb_body_O) (\lambda y : nat -> bool. (divides)  ((match_bool_type) (nat) ((gcd_aux)  (O)  m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) (((((eq_filter_nat_type_O) (nat -> bool)) ((leb_body) )) (\lambda y : nat -> bool. (divides)  ((match_bool_type) (nat) ((gcd_aux)  (O)  m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) ((((eq_leb) ((O) )) (\lambda y : nat -> bool. (divides)  ((match_bool_type) (nat) ((gcd_aux)  (O)  m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) (((eq_gcd_aux_body_O) (\lambda y : nat -> nat -> nat. (divides)  ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) (((((eq_filter_nat_type_O) (nat -> nat -> nat)) ((gcd_aux_body) )) (\lambda y : nat -> nat -> nat. (divides)  ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) ((((eq_gcd_aux) ((O) )) (\lambda y : nat -> nat -> nat. (divides)  ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) ((divides_n_n) ((gcd)  (O)  m)))))))))) ((divides_n_O) ((gcd)  (O)  m)))) (n)) (eqnO)))) ((((le_to_or_lt_eq) ((O) )) (n)) ((le_O_n) (n))).
